#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QTimer>
#include "ui_mainwindow.h"


namespace Ui
{
    class MainWindow;
}

class Plotter;


class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

     bool writeFile(const QString &fileName);
     int time_d, co2_d, temp_d, hum_d;



private slots:


    void on_timeButton_clicked();
    void on_stopButton_clicked();
    void on_startButton_clicked();
    void readEP1();
    bool saveAs();
    void print();
    void pdf();
    void png();
    void about();
    void copy();


private:
    Ui::MainWindow *ui;
    enum {RowCount = 5000, ColumnCount = 5};
    int dataCnt;
    QDateTime dt;




//    bool saveFile(const QString &fileName);
//    void writeSettings();

    //void setCurrentFile(const QString &fileName);
    //QString strippedName(const QString &fullFileName);


//    QString curFile;


};


#endif // MAINWINDOW_H
