/* Copyright (c) 2012   Guy WEILER         weigu[at]weigu[dot]lu

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   Licence: GPL-3        */

#include <iostream>
#include <cstdio>
#include <unistd.h>
#include "usb_hid_raw.h"
#include "hidapi.h"

/* Linux */
/*#include <linux/types.h>
#include <linux/input.h>
#include <linux/hidraw.h>*/

/* Unix */
/*#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>*/



using namespace std;
hid_device *handle;

hid_device* open_hid_device(void)
{
  // Open the device using the VID, PID,
  // and optionally the Serial number.
  hid_device *handle;
  int nonblockres;
  handle = hid_open(0x3eb, 0x005, NULL);
  if (handle == NULL) cout << "error hid_open: handle = NULL" << endl;
  else
  {
    // Set the hid_read() function to be non-blocking.
    nonblockres = hid_set_nonblocking(handle, 1);
    if (nonblockres == -1) cout << "error hid_set_nonblocking = -1" << endl;
  }
  return handle;
}

void send_to_uC(quint8 *buff2, quint8 samples) //EP2
{
  quint16 res;
  hid_device *handle;
  handle = open_hid_device();
  if (handle != NULL)
  {
    res = hid_write(handle, buff2, samples);
    if (res < 0) cout << "Fehler beim Schreiben aufgetreten!\n";

  }
  hid_close(handle);
}

void get_from_uC(quint8 *buff1, quint8 samples) //EP1
{
  quint16 res;
  hid_device *handle;
  unsigned char charbuff[samples];
  handle = open_hid_device();
  if (handle != NULL)
  {
    ;usleep(100000);         //!! Timing-Problem falls kleiner!
    res = hid_read_timeout(handle,buff1,samples,30);
    if (res < 0) cout << "Fehler beim Lesen aufgetreten!\n";
    //cout  << res << " charbuff: " << buff1 << "1" << endl;
    if (res == 31)
    {
      cout << res << " buff1: ";
      for (int j=0;j<31;j++) cout  << buff1[j];
      cout << " ende" << endl;
    }


  }
  hid_close(handle);
}


/*

 quint16 i;

 handle = usb_claim_device();
 //Achtung keine Nullbytes schicken!!
 i = usb_bulk_read(handle, 0x82, (char*) charbuff, samples, timeout);

 for (int j=0;j<i;j++)
 {
   buff1[j] = charbuff[j];
 }

*/
